int memcpy_called  = 0;
int memcpy_bytes = 0;

alternate_memcpy_tofs(unsigned char * buf1, unsigned char * buf2, int count)
{
  if(count & 1) *buf1++ = *buf2++;
  if(count & 2) *((unsigned short *) buf1)++ = *((unsigned short *) buf2)++;
  count >>= 2;
  while(count--) *((unsigned long *) buf1)++ = *((unsigned long *) buf2)++;
#if 0
  count >>= 2;
  while(count--) *((unsigned long *) buf1)++ = *((unsigned long *) buf2)++;
#endif
}

char too[8192];


void non_inline_memcpy_tofs(void * to, const void * from, unsigned long n)
{
#if 1
__asm__("cld\n\t"
	"push %%es\n\t"
	"push %%fs\n\t"
	"pop %%es\n\t"
	"testb $1,%%cl\n\t"
	"je 1f\n\t"
	"movsb\n"
	"1:\ttestb $2,%%cl\n\t"
	"je 2f\n\t"
	"movsw\n"
	"2:\tshrl $2,%%ecx\n\t"
	".align 4,0x90 \n\t"
	"rep ; movsl\n\t" 
	"pop %%es"
	: /* no outputs */
	:"c" (n),"D" ((long) to),"S" ((long) from)
	:"cx","di","si");
#endif
         memcpy_called++;
         memcpy_bytes += n;
}

void non_inline_memcpy_fromfs(void * to, const void * from, unsigned long n)
{
#if 1
__asm__("cld\n\t"
	"testb $1,%%cl\n\t"
	"je 1f\n\t"
	"fs ; movsb\n"
	"1:\ttestb $2,%%cl\n\t"
	"je 2f\n\t"
	"fs ; movsw\n"
	"2:\tshrl $2,%%ecx\n\t"
	"rep ; fs ; movsl"
	: /* no outputs */
	:"c" (n),"D" ((long) to),"S" ((long) from)
	:"cx","di","si");
#endif
}

